#include "projects\comms.h"
#include "projects\trainer.h"
#include <stdio.h>
#include <stdlib.h>

/*demo upload/download of gs active codelist*/

int main(){
unsigned short val;
unsigned long target;
unsigned long num;
FILE *tmp;

printf("Adding four active codes to list.\nPress [Enter] to continue...");
getchar();
if(AddActiveCode(0x81400000,0x0123)) erratta(1);
if(AddActiveCode(0x81400002,0x4567)) erratta(1);
if(AddActiveCode(0x81400004,0x89AB)) erratta(1);
if(AddActiveCode(0x81400006,0xCDEF)) erratta(1);
num=NumActiveCodes();
printf("\nDone.  %li codes in list.\n",num);

printf("\n\nDemonstrating a delete function.\n");
printf("#%d will be deleted.\nPress [Enter] to continue...",num-2);
getchar();
if(RubActiveCode(0x81400002)) printf("\nError!  RubActiveCode returned something funny...");
num=NumActiveCodes();
printf("\nDone.  %li codes in list.\n",num);

printf("\nNow to read active codes.\nPress [Enter] to continue...");
getchar();
tmp=tmpfile();
target=PrintActiveCodes(tmp);
if(target!=num) printf("\nError!  PrintActiveCodes returned %li, not %li.\n",target,num);
for(val=0;val<target;val++) {
	fseek(tmp,val*8,SEEK_SET);
	fread(&num,4,1,tmp);
	printf("\n\t%i\t%08lX ",val+1,num);
	fread(&num,4,1,tmp);
	printf("%04lX",num&0xFFFF);
}
printf("\nDone.  Press [Enter] to continue.");
getchar();

printf("\n\nNext to toggle the code lists.");
printf("\nThey were %s",GetCodeState() ? "on":"off");
printf(" and now they are %s\n(hopefully that reads off!)",SetCodeState(0) ? "on":"off");
/*extend GSmemory editor range and set initial location*/
if(InitGSComms()) erratta(1);
ReadWriteByte(2);
Write16(0xA0791DF6,0);
Write16(0xA0791E02,0);
Write16(0xA0791E32,0);
Write16(0xA0791E36,0);
Write16(0xA0791E06,0xFFFF);
Write16(0xA0791E3A,0xFFFF);
Write32(0xA07E9C90,0x80400006);
Write32(0xA07E9CA8,0x80400006);
Write16(0x80400006,0);
ReadWrite32(0);
ReadWrite32(0);
if(!CloseGSComms()) erratta(3);
printf("\nThe PC has been disconnected.  Enter Memory Editor from the GS menu.\n");
printf("Go to 80400006.  It should read '0000', not 'CDEF'.\n");
printf("Press [Enter] after closing the GS menus to resume testing.\n");
getchar();

printf("\n\nFinally, mop up by clearing the active code list.");
if(EraseAllCodes()) erratta(1);
if(!CloseGSComms()) erratta(3);
printf("\nDone.  The code list has been deleted.");
printf("\nPress [Enter] to quit.");
getchar();

return 0;}
